const gulp = require("gulp");
const eslint = require("gulp-eslint");
const gulpSequence = require("gulp-sequence");
const config = require("../config");


gulp.task("jslint:source", () => gulp.src([`${config.sourceDirectory}/**/*.js`, "!**/*.test.js"])
    .pipe(eslint())
    .pipe(eslint.format()));

gulp.task("jslint:tests", () => gulp.src([`${config.sourceDirectory}/**/*.test.js`])
    .pipe(eslint({
        envs: [
            "mocha",
        ],
        globals: [
            "sinon",
            "expect",
        ],
    }))
    .pipe(eslint.format()));

gulp.task("jslint:gulp", () => gulp.src([`${__dirname}/**/*.js`])
    .pipe(eslint({
        envs: [
            "node",
        ],
    }))
    .pipe(eslint.format()));

gulp.task("jslint", (cb) => {
    gulpSequence("jslint:source", "jslint:tests", "jslint:gulp", cb);
});
