const gulp = require("gulp");
const rename = require("gulp-rename");
const replace = require("gulp-replace");
const config = require("../config");
const packageJson = require("../../package.json");

gulp.task("rev", () => gulp.src(`${config.buildDirectory}/**/*.*`)
    .pipe(rename((path) => {
        if (path.extname === ".map") {
            path.basename = path.basename.substr(0, path.basename.lastIndexOf("."));
            path.extname = ".js.map";
        }
        path.extname = `.${packageJson.version}${path.extname}`;
    }))
    .pipe(replace(/sourceMappingURL=(.+).js(\.?.*)/, `sourceMappingURL=$1.${packageJson.version}.js$2`))
    .pipe(replace(/"sources":\["(.+).js(\.?.*)"\]/, "\"sources\":[\"$1.' + packageJson.version + '.js$2\"]"))
    .pipe(gulp.dest(config.buildDirectory)));
